﻿angular.module('smartHrass.controllers', [])
    .controller('UserLoginCtrl', function ($scope, cmUtil, $ionicHistory, $interval, $ionicPopup) {
        $scope.logInfo = {};
        $scope.mdl = {
            sendCountdown: 0,
            sendBtnText: "发送验证码"
        };

        $scope.sendCode = function() {
            if (!$scope.logInfo.idCardNum || $scope.logInfo.idCardNum.length !== 18) {
                cmUtil.alert("请输入正确的身份证号");
                return;
            }
            cmUtil.post('/user/SendVerCode', $scope.logInfo, function(res) {
                if (!res.data.error) {
                    $scope.mdl.sendCountdown = 60;
                    var interval = $interval(function () {
                        $scope.mdl.sendCountdown--;
                        if ($scope.mdl.sendCountdown > 0) {
                            $scope.mdl.sendBtnText = $scope.mdl.sendCountdown + "秒后可重发";
                        } else {
                            $interval.cancel(interval);
                            interval = undefined;
                            $scope.mdl.sendBtnText = "发送验证码";
                        }
                    }, 1000, 60);
                    $scope.mdl.sendPhoneDes = "已向手机 " + res.data.phoneNum + " 发送短信验证码";
                } else {
                    $scope.mdl.sendPhoneDes = null;
                }
            });
        };
        /*--------commented by felix 01/11/2016----------
        $scope.doLogin = function() {
            var error = null;
            if (!$scope.logInfo.idCardNum || $scope.logInfo.idCardNum.length !== 18) error = "请输入正确的身份证号";
            else if (!$scope.logInfo.verifyCode) error = "请输入接收到的短信验证码";
            if (error) {
                cmUtil.alert(error);
                return;
            }
            //submit login
            cmUtil.post('/user/LoginByVcode', $scope.logInfo, function(res) {
                if (!res.data.error && res.data.idCardNum) {
                    cmUtil.setLoginState(res.data.idCardNum);
                    $ionicHistory.goBack();
                }
            });
        };
        ----------replaced the above with the following----------*/
        $scope.doLogin = function () {
            var error = null;
            if (!$scope.logInfo.idCardNum || $scope.logInfo.idCardNum.length !== 18) error = "请输入正确的身份证号";
            else if (!$scope.logInfo.phoneNum) error = "请输入预留手机号";
            else if (!$scope.logInfo.socCardNum) error = "请输入社会保障卡号后四位";
            if (error) {
                $ionicPopup.alert({ title: '检查输入', template: error });
                return;
            }
            //submit login
            cmUtil.post('/user/Login', $scope.logInfo, function (res) {
                if (!res.data.error && res.data.idCardNum) {
                    cmUtil.setLoginState(res.data.idCardNum);
                    $ionicHistory.goBack();
                }
            });
        };

        //show back button
        $scope.$on('$ionicView.beforeEnter', function(event, viewData) { viewData.enableBack = true; });
    })
    .controller('UserReAuthCtrl', function ($scope, cmUtil, $state) {
        var idnum = cmUtil.reAuthState();
        if (!idnum || idnum.length < 15) {
            $state.transitionTo("tab.index");
            return;
        }

        $scope.user = {};
        $scope.idCard = idnum.substr(0, 6) + "*****";
        $scope.doAuth = function() {
            var error = null;
            if (!$scope.user.phoneNum) error = "请输入预留手机号";
            else if (!$scope.user.idCardNum) error = "请输入身份证号后六位";
            if (error) {
                cmUtil.alert(error);
                return;
            }
            //submit auth
            cmUtil.post('/user/ReAuthUser', $scope.user, function (res) {
                if (!res.data.error && res.data.idCardNum) {
                    cmUtil.setLoginState(res.data.idCardNum);
                    cmUtil.reAuthState('');
                    $state.transitionTo("tab.index");
                }
            });
        };
    })
    .controller('IndexCtrl', function () {
        Swipe(document.getElementById('indexAdvSlider'), { auto: 3500 });
    })
    .controller('SiteNavCtrl', function ($scope, cmUtil) {
        cmUtil.post('/guide/SiteNav', null, function (res) {
            $scope.dtl = res.data.dtl;
        });
    })
    .controller('CommonSocSrtCtrl', function($scope, cmUtil, $state) {
        var business = ($state.current.views['tab-index'] || $state.current.views['tab-socsrt'])['business'];
        cmUtil.get('/socsrt/' + business, null, function(res) {
            if (res.data.row) $scope.row = res.data.row;
            if (res.data.rowList) $scope.rowList = res.data.rowList;
        });
    })
    .controller('CommonMonthQryCtrl', function($scope, cmUtil, $state) {
        var business = $state.current.views['tab-index']['business'];
        var pageIndex = 0;
        angular.extend($scope, {
            rowList: [],
            canLoadMore: true,
            monthSet: {
                qryMonth: '',
                monthList: cmUtil.monthList(36, true)
            },
            loadMore: function (reload) {
                if (reload) {
                    pageIndex = 0;
                    $scope.rowList = [];
                }
                
                pageIndex++;
                cmUtil.get('/socsrt/' + business, { month: $scope.monthSet.qryMonth, page: pageIndex }, function (res) {
                    if (res.data.rowList) {
                        res.data.rowList.forEach(function(p) {
                            $scope.rowList.push(p);
                        });
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.canLoadMore = res.data.canLoadMore;
                });
            }
        });
    })
    .controller('CommonInsPaymentCtrl', function($scope, cmUtil, $stateParams) {
        var months = cmUtil.monthList(36);
        angular.extend($scope, {
            monthSet: {
                qryMonth: months[0],
                monthList: months
            },
            loadData: function () {
                cmUtil.post('/socsrt/InsuredPaymentInfo', { type: $stateParams.type, month: $scope.monthSet.qryMonth }, function (res) {
                    $scope.typeName = res.data.typeName;
                    $scope.rowList = res.data.rowList;
                });
            }
        });
        $scope.loadData();
    })
    .controller('ResidentPaymentQryCtrl', function ($scope, cmUtil) { //by felix in Jan.4 2017
        $scope.rowList = [];
        $scope.resident = {};
        var rowNum = 1;
        var queryName;
        var queryIdCardNum;
        angular.extend($scope, {
            doQuery: function () {
                var error = null;
                if (!$scope.resident.idCardNum || $scope.resident.idCardNum.length != 18) error = "请输入正确的身份证号";
                else if (!$scope.resident.name) error = "请输入正确的姓名";
                if (error) { cmUtil.alert(error); return false; }

                queryName = $scope.resident.name;
                queryIdCardNum = $scope.resident.idCardNum;
                rowNum = 1;

                cmUtil.post('/socsrt/ResidentPaymentInfo', { name: $scope.resident.name, idcard: $scope.resident.idCardNum }, function (res) {
                    $scope.rowList = res.data.rowList ? res.data.rowList : [];
                    $scope.canLoadMore = res.data.recordCount > 4;
                    rowNum += 5;
                });
            },
            canLoadMore: false,
            loadMore: function () {
                cmUtil.post('/socsrt/ResidentPaymentInfo', { name: queryName, idcard: queryIdCardNum, rownum: rowNum }, function (res) {
                    if (res.data.rowList) {
                        angular.forEach(res.data.rowList, function (row) {
                            $scope.rowList.push(row);
                        });
                    }
                    rowNum += 5;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.canLoadMore = res.data.recordCount > 4;
                });
            }
        });
    })
    .controller('PenYearStdBkCtrl', function ($scope, cmUtil) {
        var years = cmUtil.yearList(5);
        angular.extend($scope, {
            yearSet: {
                qryYear: years[0],
                yearList: years
            },
            loadData: function () {
                cmUtil.post('/socsrt/PensionYearStdBook', { year: $scope.yearSet.qryYear }, function(res) {
                    $scope.rowList = res.data.rowList;
                });
            }
        });
        $scope.loadData();
    })
    .controller('SocSrtCtrl', function ($scope, $ionicPopup, cmUtil) {
        //card loss
        $scope.regData = { name: '', phone: '' };
        $scope.popoverShow = function () {
            $ionicPopup.show({
                title: "社保卡挂失",
                templateUrl: "popLossReg.html",
                buttons: [
                    { text: '取消' },
                    {
                        text: '挂失',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.regData.name || !$scope.regData.phone) {
                                e.preventDefault();
                                return;
                            }
                            cmUtil.post("/socsrt/RegSocCardLoss", $scope.regData, function (res) {
                                if (!res.data.error) $ionicPopup.alert({ title: '操作成功', template: "已成功挂失社保卡" });
                            });
                        }
                    }
                ],
                scope: $scope
            });
        };

        //article list
        var pageIndex = 0;
        angular.extend($scope, {
            rowList: [],
            canLoadMore: true,
            loadMore: function () {
                pageIndex++;
                cmUtil.get('/guide/SocCardArtList', { page: pageIndex }, function (res) {
                    if (res.data.rowList) {
                        res.data.rowList.forEach(function (p) {
                            $scope.rowList.push(p);
                        });
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.canLoadMore = res.data.canLoadMore;
                });
            }
        });
    })
    .controller('CommonArtListCtrl', function ($scope, cmUtil, $stateParams) {
        var pageIndex = 0;
        angular.extend($scope, {
            type: $stateParams.type,
            rowList: [],
            canLoadMore: true,
            loadMore: function() {
                pageIndex++;
                cmUtil.post('/guide/ArticalList', { type: $scope.type, page: pageIndex }, function(res) {
                    if (res.data.navTitle) $scope.navTitle = res.data.navTitle;
                    if (res.data.rowList) {
                        res.data.rowList.forEach(function(p) {
                            $scope.rowList.push(p);
                        });
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.canLoadMore = res.data.canLoadMore;
                });
            }
        });
    })
    .controller('CommonArtDetailCtrl', function ($scope, cmUtil, $stateParams) {
        cmUtil.post('/guide/ArticalDetail', { type: $stateParams.type, id: $stateParams.id }, function (res) {
            $scope.navTitle = res.data.navTitle;
            $scope.row = res.data.row;
        });
    })
    .controller('PtArticleListCtrl', function ($scope, cmUtil, $state) {
        var loadUrl = $state.current['loadUrl'];
        var pageIndex = 0;
        angular.extend($scope, {
            rowList: [],
            canLoadMore: true,
            loadMore: function () {
                pageIndex++;
                cmUtil.get(loadUrl, { page: pageIndex }, function (res) {
                    if (res.data.rowList) {
                        res.data.rowList.forEach(function (p) {
                            $scope.rowList.push(p);
                        });
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.canLoadMore = res.data.canLoadMore;
                });
            }
        });
    })
    .controller('PtArticleDetailCtrl', function ($scope, cmUtil, $stateParams) {
        var cats = ["公示公告", "社保卡专栏", "热点问题"];
        $scope.navTitle = cats[$stateParams.type];
        cmUtil.post('/guide/PtArticleDetail', { id: $stateParams.id }, function (res) {
            $scope.dtl = res.data.dtl;
            $scope.atc = res.data.atc;
            if ($scope.dtl && !$scope.dtl.txt) $scope.dtl.txt = "无内容展示";
        });
    })
    .controller('MySetCtrl', function($scope, $ionicPopup, cmUtil, $state) {
        angular.extend($scope, {
            logout: function() {
                if (!cmUtil.isLogined()) return;
                cmUtil.confirm("确定要退出当前登陆的账号吗？", function() {
                    cmUtil.get("/user/Logout", null, function(res) {
                        if (res.data.error) $ionicPopup.alert({ title: '请求异常', template: res.data.error });
                        else {
                            cmUtil.removeLoginState();
                            $state.go("tab.index");
                        }
                    });
                });
            },
            weibo:function() {
                var url = "http://m.weibo.cn/d/dyrswb";
                if (cordova && cordova.InAppBrowser) cordova.InAppBrowser.open(url, '_blank', 'location=yes');
                else window.open(url);
            },
            citysrv:function() {
                $ionicPopup.alert({
                    template: "打开微信→我的钱包→城市服务→社保查询（“位置”需选择“德阳”）",
                    okText: "确定"
                });
            }
        });

        if (cmUtil.isLogined()) {
            cmUtil.get("/user/GetBrefInfo", null, function(res) {
                angular.extend($scope, res.data);
            });
            $scope.isLogined = true;
        }
    })
    .controller('AboutAppCtrl', function ($scope, cmUtil) {
        cmUtil.getAppVersion(function (version) {
            $scope.version = version;
        });

        if (ionic.Platform.isAndroid()) $scope.platform = "Android";
        else if (ionic.Platform.isIOS()) $scope.platform = "IOS";
    })
    .controller('FramePageCtrl', function ($scope, $stateParams, $sce) {
        $scope.title = $stateParams.title;
        $scope.frameUrl = $sce.trustAsResourceUrl($stateParams.url);
    });